#include <stdio.h>
#include "p4.h"
#include "data.h"

#define PATH "/tmp_mnt/home/A10E/ryadav"
#define MAP_FILE 0

int VCE_init(argc, argv)
int argc;
char* argv[];
{
	p4_initenv(&argc, argv);
    p4_create_procgroup();
    return SUCCESS;
}

int VCE_machinelist(int **list, int *total_machines)
{
  int i;

  *list = (int*) malloc((p4_num_total_slaves() - 1)* sizeof(int));
  *total_machines  = p4_num_total_slaves() - 1;
  for(i = 0; i < *total_machines; i++)
	  (*list)[i] = i+1;
  return SUCCESS;
}


int VCE_launch(int machine_type, char *executable_file, char* command_line, int number_of_nodes, void* task_id)
{
  message_ptr message;
  struct message mesg;
  int from, type, size;
  int *dummy = NULL;
 
  if(machine_type > p4_num_total_slaves())
     return WR_MACHINE;;

  message = &mesg;

  message->type = EXECUTE;
  message->NODES =  number_of_nodes;
  message->task_id = task_id;;
  sprintf(message->command, "%s %s", executable_file, command_line);

  if(machine_type == ALPHA)
     writefile(message);
 

  p4_send(COMMAND1, machine_type, (char*)message, sizeof(struct message));

  /* wait for response from remote machine */
  type = DONE;
  p4_recv(&type, &machine_type, &dummy, &size);
  return SUCCESS;
}

int VCE_wait_for_status(int *machine_type,
                                     void** task_id)
{
  int done = 0;
  int type, from, size;
  char *temp;
  message_ptr message;
  struct message mesg;

  message = &mesg;
  
  while(!done){
    type = -1;
    from = -1;
    message = NULL;
    p4_recv(&type, &from, &message, &size);

   if(from <= p4_num_total_slaves() && type >= SUCCESS &&
type <= WR_MACHINE)
      done = 1;
  }

  if(from == ALPHA)
     read_file(message);

/*
  *executable_file = (char*) malloc(sizeof(message->command)+1);
  p4_dprintf("executable %s\n", message->command);
  strcpy(*executable_file, message->command);
*/
  *machine_type = from;
  *task_id = message->task_id;
  return type;
}  


int VCE_cleanup(char* filename, int* machine_list, int winner)
{
  message_ptr message;
  struct message mesg;
  int i = 0;
  int type, from, size, *dummy = NULL;

  message = &mesg;

  sprintf(message->command, "%s", filename);
  while(machine_list[i] != 0) {
	if(machine_list[i] != winner)
       message->type = CLEANUP;
    else 
       message->type = CLEANUP_COPY;
    
    if(machine_list[i] == ALPHA)
       writefile(message);
    p4_send(COMMAND1,machine_list[i],(char*)message,sizeof(struct message));
    i++;
  }  
  type = DONE;
  from = winner;
  p4_recv(&type, &from, &dummy, &size); 
  return SUCCESS;
}

int VCE_copy_inputfile(char* filename, int* machine_list, int winner)
{
  message_ptr message;
  struct message mesg;
  struct stat statbuf;
  int i = 0;
  int type, from, size, *dummy, dummy1;
  char *command, *src;
  int fp, flag = 0;

  message = &mesg;

  if(winner == 0){
     message->type = INPUT_FILE;
     sprintf(message->command, "%s", filename);
     while(machine_list[i] != 0) {
        if(machine_list[i] == ALPHA)
           writefile(message);
        p4_send(COMMAND1, machine_list[i],(char*)message,sizeof(struct message));
        i++;
     }

/*
     command = (char*) malloc(sizeof(filename) + 2*sizeof(PATH)+100);


     sprintf(command, "%s/VCE/DATA/%s", PATH, filename);
     if((fp = open(command, O_RDONLY)) < 0){
        p4_dprintf("Cann't open input data file %s\n", command);
        i = 0;
        while(machine_list[i] != 0) {
           p4_send(INPUT_FILE, machine_list[i], &dummy1, statbuf.st_size);
           i++;
        }
        return -1;
     }
 
     fstat(fp, &statbuf);
     src = mmap(0, statbuf.st_size, PROT_READ, MAP_FILE | MAP_SHARED, fp, 0) ;

     p4_dprintf("Sending the Input file %s\n", filename);
     i = 0;
     while(machine_list[i] != 0) {
        p4_send(INPUT_FILE, machine_list[i], src, statbuf.st_size);
        i++;
     }
     munmap(src, statbuf.st_size);
     close(fp);
*/
	 i = 0;
     while(machine_list[i] != 0){
 	   dummy = NULL;
       from = machine_list[i];
 	   type = DONE;
       p4_recv(&type, &from, &dummy, &size);
  	   i++;
     }

     return SUCCESS;

  }
  else {
    while(machine_list[i] != 0) {
	  if(machine_list[i] == winner){
         message->type = BROADCAST;
         flag = 1;
      }
      else 
         message->type = RECEIVE;

      sprintf(message->command, "%s", filename);
      if(machine_list[i] == ALPHA)
         writefile(message);
      p4_send(COMMAND1, machine_list[i],(char*)message,sizeof(struct message));
      i++;
   }

/*
      if(machine_list[i] == winner){
          if(machine_list[i] == ALPHA)
              sendlist(machine_list, 0);
          p4_send(MESSAGE, machine_list[i], (char*)machine_list,sizeof(int)*10);
      }
      else {
          if(machine_list[i] == ALPHA)
              sendlist(&winner, 1);
         p4_send(MESSAGE,machine_list[i], &winner, sizeof(int));
      }
   
      i++;
    }  
*/
    if(flag == 0) {
       message->type = BROADCAST;
       sprintf(message->command, "%s", filename);
       if(winner == ALPHA)
	      writefile(message);
       p4_send(COMMAND1, winner,(char*)message,sizeof(struct message));
/*
       p4_send(MESSAGE, winner, machine_list,sizeof(int)*10);
*/
    }
    type = DONE;
    from = winner;
    dummy = NULL;
    p4_recv(&type, &from, &dummy, &size);
    return SUCCESS;
  }
}


int VCE_kill_executable(int machine_type,
                                    void* task_id)
{
  message_ptr message;
  struct message mesg;
  int *dummy;
  int type, size;

  if(machine_type > p4_num_total_slaves())
     return WR_MACHINE;;

  message = &mesg;
  message->type = ABORT;
  message->task_id = task_id;
  if(machine_type == ALPHA)
      writefile(message);
  p4_send(COMMAND1, machine_type, (char*)message, sizeof(struct message));
  
  type = KILLED;
  dummy = NULL;
  p4_recv(&type, &machine_type, &dummy, &size);
  return SUCCESS;
}

void VCE_shutdown()
{
  message_ptr message;
  struct message mesg;
  int i;

  message = &mesg;

  message->type = SHUTDOWN;
  for(i=1;i<p4_num_total_ids(); i++){
    if(i == ALPHA)
       writefile(message); 
    p4_send(COMMAND1, i, (char*)message, sizeof(struct message));
  }
  p4_wait_for_end();
  p4_dprintf("DONE....\n");
}


int VCE_getload(int* list, int **load)
{
  message_ptr message, recv_mesg;
  struct message mesg;
  int i = 0;
  int from, type, size;
  int load_manager;

  message = &mesg;

  *load = (int*) malloc(sizeof(int)*4);
    
  i = 0;
  load_manager = p4_num_total_slaves();
  message->type = LOAD;
  while(list[i] != 0){
   if(list[i] < load_manager && list[i] > 0){
     message->NODES = list[i];
	p4_send(COMMAND1, load_manager, message, sizeof(struct message));
    from = load_manager; 
    recv_mesg = NULL;
	type  = LOAD;
	p4_recv(&type, &from, &recv_mesg, &size);
    (*load)[i] = recv_mesg->NODES;
    p4_msg_free(recv_mesg);
   }
   else
    (*load)[i] = 0;
   i++;
  }
  return SUCCESS;
  
}

writefile( message)
message_ptr message;
{
   FILE *fp;

   fp = fopen("message","w");

   fprintf(fp, "%d\n",message->type);
   fprintf(fp, "%d\n",message->NODES);
   fprintf(fp, "%d\n",message->task_id);
   fprintf(fp, "%s",message->command);
   fclose(fp);
}

read_file(message)
message_ptr message;
{
  FILE *fp;

  if((fp = fopen("response", "r")) == NULL){
	p4_dprintf("Could not open file response\n");
	exit(1);
  }
  fscanf(fp, "%d", &message->type);
  fscanf(fp, "%d\n", &message->NODES);
  fscanf(fp, "%d\n", &message->task_id);
  fgets(message->command, 400, fp);
  fclose(fp);
}

sendlist(list, flag)
int *list;
int flag;
{
  FILE *fp;
  int i = 0;
  
  fp = fopen("list", "w");
  fprintf(fp, "%d\n", flag);
  if(flag == 1)
	 fprintf(fp, "%d\n", *list);

  else {
    while(list[i] != 0){
	   fprintf(fp, "%d\n", list[i]);
	   i++;
	}
	fprintf(fp, "%d\n", list[i]);
  }
  fclose(fp);
  return;
}
